;******************************************
;*                                        *
;*   C O D E D   B Y                      *
;*                                        *
;*                                        *
;*              ### # # ###               *
;* EXECUTE OF    #  # # #                 *
;*               #  ### ##                *
;*               #  # # #                 *
;*               #  # # ###               *
;*                                        *
;* ### # # ##  ### ##  # ### #  #  ## ### *
;* #   # # # # #   # # # #   ## # #   #   *
;* ##   #  ##  ##  ##  # ##  # ## #   ##  *
;* #   # # #   #   # # # #   #  # #   #   *
;* ### # # #   ### # # # ### #  #  ## ### *
;*                                        *
;******************************************
;
; HI ! THIS IS XQT(EXECUTE) OF 
; THE EXPERIENCE. THIS PROGRAMM SHOWS
; A SIMPLE (BUT OK!) PLATFORM-GAME.
; TECNIQUES:
;   - 4 PLANES PRE-SHIFTED FOREGROUND
;   - 2 PLANES PRE-SHIFTED BACKGROUND
;   - ^(6)PLANES + 2  ->   SPRITES
;     '
; IF YOU USE THE SOURCE:
;
;  SEND 15 GUILDERS TO THIS ADDRESS:
;  SPINOZALAAN 18
;  HAREN,THE NETHERLANDS
;
; --- HAVE FUN WITH IT ! ---


mousevec	EQU	16
ikbdws		EQU	25
kbdvec		EQU	34
aantblok	EQU	42

;- INIT -

	bsr	schermadr_opvraag
	bsr	install_mouse
	bsr	cls
	bsr	pre_calc_veld
	bsr	sup_vis_mode
	bsr	save_colors
	bsr	set_colors
	bsr	do_shift
	bsr	last_init
	bsr	vsync
;************************************
;------------------------------------
;------------------------------------
;************************************


back:
	bsr	veldcop



;---------------------------;
;*** SLOW DOWN EVERY VBL ***;
;---------------------------;


; - (X) -

; IF mx>32+2 THEN mx=mx-2
	cmp.w	#32+2,mousex
	blo	lower_34
	sub.w	#2,mousex
	bra	endif1
lower_34:
; IF mx<32-2 THEN mx=mx+2
	cmp.w	#32-2,mousex
	bhi	higher_30
	add.w	#2,mousex
	bra	endif1
higher_30:
	move.w	#32,mousex
endif1:

; - (Y) -

	cmp.w	#32+2,mousey
	blo	lower_34_2
	sub.w	#2,mousey
	bra	endif2
lower_34_2:
	cmp.w	#32-2,mousey
	bhi	higher_30_2
	add.w	#2,mousey
	bra	endif2
higher_30_2:
	move.w	#32,mousey
endif2:

; ELSE



;-------------------;
;*** NOT TO FAST ***;
;-------------------;

	cmp.w	#16,mousex
	bhi	not_16
	move.w	#16,mousex
not_16:
	cmp.w	#47,mousex
	blo	not_47
	move.w	#47,mousex
not_47:

	cmp.w	#16,mousey
	bhi	not_16_2
	move.w	#16,mousey
not_16_2:
	cmp.w	#47,mousey
	blo	not_47_2
	move.w	#47,mousey
not_47_2:

;------------;
;*** NEWX ***;
;------------;

	move.w	mousex,d0
	add.w	d0,cntrx
	sub.w	#32,cntrx ; centrate

	move.w	mousey,d0
	add.w	d0,cntry
	sub.w	#32,cntry ; centrate

;----------------------------;
;*** NOT OUT OF PLAYFIELD ***;
;----------------------------;

	tst	cntrx
	bpl	not_negative
	move.w	#0,cntrx
not_negative:
	cmp.w	#16*30-1,cntrx
	blo	not_negativ1
	move.w	#16*30-1,cntrx
not_negativ1:

	tst	cntry
	bpl	not_negativ2
	move.w	#0,cntry
not_negativ2:
	cmp.w	#16*10-1,cntry
	blo	not_negativ3
	move.w	#16*10-1,cntry
not_negativ3:

;---------------------;
;*** UPDATE SCREEN ***;
;---------------------;

	move.l	#veld,a0
	move.w	cntry,d0
	asr.w	#4,d0	; per 16 pixels
	mulu	#(2*4*20),d0 ; 1 hoog
	add.w	d0,a0
	move.w	cntrx,d0
	asr.w	#4,d0
	asl.w	#1,d0
	add.w	d0,a0


	move.w	cntry,d0
	and.w	#15,d0
	tst.w	d0
	beq.s	zero_in_field

; ***********************

	move.w	(a0),d1
	tst	d1
	beq.s	tszero
	move.w	cntrx,d0
	and.w	#$FFF0,d0
	move.w	d0,cntrx
	move.w	#32,mousex
tszero:
	move.w	2*4*20(a0),d1
	tst	d1
	beq.s	tszero2
	move.w	cntrx,d0
	and.w	#$FFF0,d0
	move.w	d0,cntrx
	move.w	#32,mousex
tszero2:

	move.w	#24*128,(a0)
	move.w	#24*128,2*4*20(a0)
	bra	endif4

zero_in_field:  ;********

	move.w	(a0),d1
	tst	d1
	beq.s	tszero3
	move.w	cntrx,d0
	and.w	#$FFF0,d0
	move.w	d0,cntrx
	move.w	#32,mousex
tszero3:
	move.w	#24*128,(a0)

endif4:  ;***************


	move.w	#$100,$ff8240
	bsr	cop
	move.l	schermadres,a0

	move.w	cntrx,d0
	move.w	d0,2(a0)
	move.w	#15,(a0)

	move.w	cntry,d0
	move.w	d0,322(a0)
	move.w	#15,320(a0)

	move.w	#$000,$ff8240
	bsr	vsync

	move	#$b,-(sp)
	trap	#1
	addq.l	#2,sp
	tst.w	d0
	beq	back


;- LEAVE -

	bsr	rest_colors
	bsr	restore_mouse
	bsr	user_mode

	clr.l	-(sp)
	trap	#1


;************************************
;------------------------------------
;------------------------------------
;************************************


;	SUBROUTINES    !!!!!
;-------------------------------
last_init:
	move.w	#32,mousex
	RTS
;-------------------------
pre_calc_veld:
	move.l	#veld,a0
	move.l	#veldlen/2-1,d0
veldlus:
	move.w	(a0),d1
	mulu	#128,d1
	move.w	d1,(a0)+
	dbra	d0,veldlus

	RTS
;-------------------------
do_shift:

	move.l	#shiftpic,a1

	move.l	#16-1,d6
shiftlus2:

	move.l	#tabel1,a3
	move.l	#blokpic+34,a0
	move.l	#aantblok-1,d7
shiftlus:

ad set 0
	REPT	16
	move.l	ad*160(a0),d0
	move.w	d0,d2 ;pl2->d2.r
	swap	d0
	move.w	d0,d1 ;pl1->d1.r

	move.l	ad*160+4(a0),d0
	move.w	d0,d4 ;pl2->d2.r
	swap	d0
	move.w	d0,d3 ;pl1->d1.r


	swap	d1 ;r=l,l=r
	swap	d2
	swap	d3
	swap	d4

	move.l	ad*160+8(a0),d0
	move.w	d0,d2 ;pl2->d2.r
	swap	d0
	move.w	d0,d1 ;pl1->d1.r

	move.l	ad*160+12(a0),d0
	move.w	d0,d4 ;pl2->d2.r
	swap	d0
	move.w	d0,d3 ;pl1->d1.r

	asr.l	d6,d1
	asr.l	d6,d2
	asr.l	d6,d3
	asr.l	d6,d4

	move.w	d1,d0
	swap	d0
	move.w	d2,d0
	move.l	d0,ad*8(a1)

	move.w	d3,d0
	swap	d0
	move.w	d4,d0
	move.l	d0,ad*8+4(a1)
ad set ad+1
	ENDR

	add.l	#16*8,a1
	add.w	(a3)+,a0
	add.w	(a3)+,a0

	dbra	d7,shiftlus
	dbra	d6,shiftlus2

	RTS
;-------------------------
vsync:
	movem.l	d0-d7/a0-a6,-(sp)
	move	#37,-(sp)
	trap	#14
	addq.l	#2,sp
	movem.l	(sp)+,d0-d7/a0-a6
	RTS
;-------------------------
wacht_toets:
	move	#7,-(sp)
	trap	#1
	addq.l	#2,sp
	RTS
;-------------------------
sup_vis_mode:
	pea	0
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	move.l	d0,ssp
	RTS
;-------------------------
user_mode:
	move.l	ssp,-(sp)
	move	#$20,-(sp)
	trap	#1
	addq.l	#6,sp
	RTS
;-------------------------
cls:
	move.l	#(320*240)/4/4-1,d0
	move.l	schermadres,a0
go_cls:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra d0,go_cls
	RTS
;-------------------------
cop:
	move.l	schermadres,a1
	add.w	#320*32,a1
	move.l	#tabel2,a2
	move.l	#veld,a3
	move.l	#shiftpic,a4


	move.w	cntrx,d0
	and.w	#15,d0
	mulu	#aantblok*16*8,d0
	add.l	d0,a4

	clr.l	d0
	move.w	cntrx,d0
	asr.w	#4,d0
	asl.w	#1,d0
	add.w	d0,a3

	move.w	#11-1,d6
lus2:
	move.w	#20-1,d7
lus:
	move.l	a4,a0
	add.w	(a3)+,a0
ad set 0
	REPT	16
	move.l	ad*8(a0),ad*320(a1)
	move.l	ad*8+4(a0),ad*320+4(a1)
ad set ad+1
	ENDR
	add.w	(a2)+,a1
	dbra	d7,lus
	add.w	#40*3,a3
	dbra	d6,lus2
	RTS
;-------------------------
schermadr_opvraag:
	move	#2,-(sp)		; vraag screen add op
	trap	#14
	addq.l	#2,sp
	move.l	d0,schermadres	; screen add filled in d0 ->screenadd
	RTS
;-------------------------
install_mouse:
	move.w	#kbdvec,-(sp)
	trap	#14
	addq.l	#2,a7
	lea	my_handler,a1
	move.l	d0,a0
	move.l	d0,save_old_base
	move.l	mousevec(a0),save_old_vec
	move.l	a1,mousevec(a0)
	pea	ikbdstring
	move.w	#0,-(sp)
	move.w	#ikbdws,-(sp)
	trap	#14
	addq.l	#8,sp
	RTS
;-------------------------------
restore_mouse:
	move.l	save_old_base,a0
	move.l	save_old_vec,d0
	move.l	d0,mousevec(a0)
	move.w	#0,-(sp)
	trap	#1
	RTS
;-------------------------------
my_handler:
	move.b	#3,d0
	lea	packet,a1
save_it:move.b	(a0)+,(a1)+
	subq.b	#1,d0
	bne	save_it

;(x)
	clr.w	d0
	move.b	packet+1,d0
	ext.w	d0
	add.w	d0,mousex
;(y)
	clr.w	d0
	move.b	packet+2,d0
	ext.w	d0
	add.w	d0,mousey

	move.w	#0,packet
	move.b	#0,packet+2

	RTS
;-------------------------
veldcop:
	move.l	#oldveld,a0
	move.l	#veld,a1
	move.w	#11*4*20*2/4-1,d0
veldcoplus:
	move.l	(a0)+,(a1)+
	dbra	d0,veldcoplus
	RTS
;-------------------------
save_colors:
	move.l	#$ffff9800,a0
	move.l	#old_palette,a1
	move.w	#255,d0
save_cloop:
	move.l	(a0)+,(a1)+
	dbra	d0,save_cloop
	RTS
;-------------------------
rest_colors:
	move.l	#old_palette,a0
	move.l	#$ffff9800,a1
	move.w	#255,d0
rest_cloop:
	move.l	(a0)+,(a1)+
	dbra	d0,rest_cloop
	RTS
;-------------------------
set_colors:
	move.l	#blokpic+2,a0
	move.l	#$ffff9800,a1
	move.w	#15,d2
cols:
	move.w	(a0),d0
	and.l	#$700,d0
	asr.l	#8,d0
	asl.l	#8,d0
	asl.l	#8,d0
	asl.l	#8,d0	; 31-8-3
	asl.l	#5,d0	; 31-8-3
	move.l	d0,d1

	move.w	(a0),d0
	and.l	#$70,d0
	asr.w	#4,d0
	asl.l	#8,d0
	asl.l	#8,d0
	asl.l	#5,d0	; 23-4-3
	add.l	d0,d1

	move.w	(a0),d0
	and.l	#$7,d0
	asl.l	#5,d0
	add.w	d0,d1

	add.w	#2,a0
	move.l	d1,(a1)+

	dbra	d2,cols
	RTS
;-------------------------

;	VARIABELEN
;-----------------------------------
schermadres:	dc.l	0
ssp:		dc.l	0
cntrx:		dc.w	0
cntry:		dc.w	0
ikbdstring	dc.b	$8
packet		ds.b	3
save_old_vec	ds.l	1
save_old_base	ds.l	1
old_palette:	ds.l	256

mousex:	dc.w	0
mousey:	dc.w	0

veld:
	ds.w	11*4*20
oldveld:	
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

	dc.w	 0, 0, 0, 1, 3, 3, 3, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

	dc.w	 4, 5, 6, 6, 7, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 5, 6, 6
	dc.w	 6,10,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,23,17,22,22
	dc.w	22,12,13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

	dc.w	26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,29,30,22,22
	dc.w	22,14,15,16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

	dc.w	24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,28,31,22,22
	dc.w	22,22,18,19,20,21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	dc.w	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

	REPT	600
	dc.w	3
	ENDR
veldend:
veldlen	EQU	veldend-veld

tabel1:
	REPT	13
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8
	dc.w	8+160*15
	ENDR
tabel2:
	REPT	13
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16
	dc.w	16+320*15
	ENDR
blokpic:
	INCBIN	'F:\JMP\JMPBLOK.PI1'

shiftpic:	ds.l	(32*aantblok)*16

	illegal
